diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/meta.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/meta.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/meta.php	2012-10-15 00:51:38.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/meta.php	2013-07-16 09:21:05.000000000 -0500
***************
*** 26,32 ****
   * @param bool $unique Optional, default is false. Whether the specified metadata key should be
   * 		unique for the object. If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
!  * @return bool The meta ID on successful update, false on failure.
   */
  function add_metadata($meta_type, $object_id, $meta_key, $meta_value, $unique = false) {
  	if ( !$meta_type || !$meta_key )
--- 26,32 ----
   * @param bool $unique Optional, default is false. Whether the specified metadata key should be
   * 		unique for the object. If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
!  * @return int|bool The meta ID on successful update, false on failure.
   */
  function add_metadata($meta_type, $object_id, $meta_key, $meta_value, $unique = false) {
  	if ( !$meta_type || !$meta_key )
***************
*** 40,50 ****
  
  	global $wpdb;
  
! 	$column = esc_sql($meta_type . '_id');
  
  	// expected_slashed ($meta_key)
! 	$meta_key = stripslashes($meta_key);
! 	$meta_value = stripslashes_deep($meta_value);
  	$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
  
  	$check = apply_filters( "add_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $unique );
--- 40,50 ----
  
  	global $wpdb;
  
! 	$column = sanitize_key($meta_type . '_id');
  
  	// expected_slashed ($meta_key)
! 	$meta_key = wp_unslash($meta_key);
! 	$meta_value = wp_unslash($meta_value);
  	$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
  
  	$check = apply_filters( "add_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $unique );
***************
*** 110,122 ****
  
  	global $wpdb;
  
! 	$column = esc_sql($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// expected_slashed ($meta_key)
! 	$meta_key = stripslashes($meta_key);
  	$passed_value = $meta_value;
! 	$meta_value = stripslashes_deep($meta_value);
  	$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
  
  	$check = apply_filters( "update_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $prev_value );
--- 110,122 ----
  
  	global $wpdb;
  
! 	$column = sanitize_key($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// expected_slashed ($meta_key)
! 	$meta_key = wp_unslash($meta_key);
  	$passed_value = $meta_value;
! 	$meta_value = wp_unslash($meta_value);
  	$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
  
  	$check = apply_filters( "update_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $prev_value );
***************
*** 193,203 ****
  
  	global $wpdb;
  
! 	$type_column = esc_sql($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  	// expected_slashed ($meta_key)
! 	$meta_key = stripslashes($meta_key);
! 	$meta_value = stripslashes_deep($meta_value);
  
  	$check = apply_filters( "delete_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $delete_all );
  	if ( null !== $check )
--- 193,203 ----
  
  	global $wpdb;
  
! 	$type_column = sanitize_key($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  	// expected_slashed ($meta_key)
! 	$meta_key = wp_unslash($meta_key);
! 	$meta_value = wp_unslash($meta_value);
  
  	$check = apply_filters( "delete_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $delete_all );
  	if ( null !== $check )
***************
*** 397,403 ****
  	if ( ! $table = _get_meta_table( $meta_type ) )
  		return false;
  
! 	$column = esc_sql($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// Fetch the meta and go on if it's found.
--- 397,403 ----
  	if ( ! $table = _get_meta_table( $meta_type ) )
  		return false;
  
! 	$column = sanitize_key($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// Fetch the meta and go on if it's found.
***************
*** 478,484 ****
  		return false;
  
  	// object and id columns
! 	$column = esc_sql($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// Fetch the meta and go on if it's found.
--- 478,484 ----
  		return false;
  
  	// object and id columns
! 	$column = sanitize_key($meta_type . '_id');
  	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
  
  	// Fetch the meta and go on if it's found.
***************
*** 528,534 ****
  	if ( ! $table = _get_meta_table($meta_type) )
  		return false;
  
! 	$column = esc_sql($meta_type . '_id');
  
  	global $wpdb;
  
--- 528,534 ----
  	if ( ! $table = _get_meta_table($meta_type) )
  		return false;
  
! 	$column = sanitize_key($meta_type . '_id');
  
  	global $wpdb;
  
***************
*** 678,684 ****
  		}
  
  		// WP_Query sets 'meta_value' = '' by default
! 		if ( isset( $qv[ 'meta_value' ] ) && '' !== $qv[ 'meta_value' ] )
  			$meta_query[0]['value'] = $qv[ 'meta_value' ];
  
  		if ( !empty( $qv['meta_query'] ) && is_array( $qv['meta_query'] ) ) {
--- 678,684 ----
  		}
  
  		// WP_Query sets 'meta_value' = '' by default
! 		if ( isset( $qv[ 'meta_value' ] ) && '' !== $qv[ 'meta_value' ] && ( ! is_array( $qv[ 'meta_value' ] ) || $qv[ 'meta_value' ] ) )
  			$meta_query[0]['value'] = $qv[ 'meta_value' ];
  
  		if ( !empty( $qv['meta_query'] ) && is_array( $qv['meta_query'] ) ) {
***************
*** 706,712 ****
  		if ( ! $meta_table = _get_meta_table( $type ) )
  			return false;
  
! 		$meta_id_column = esc_sql( $type . '_id' );
  
  		$join = array();
  		$where = array();
--- 706,712 ----
  		if ( ! $meta_table = _get_meta_table( $type ) )
  			return false;
  
! 		$meta_id_column = sanitize_key( $type . '_id' );
  
  		$join = array();
  		$where = array();
***************
*** 714,719 ****
--- 714,727 ----
  		$key_only_queries = array();
  		$queries = array();
  
+ 		// Split out the queries with empty arrays as value
+ 		foreach ( $this->queries as $k => $q ) {
+ 			if ( isset( $q['value'] ) && is_array( $q['value'] ) && empty( $q['value'] ) ) {
+ 				$key_only_queries[$k] = $q;
+ 				unset( $this->queries[$k] );
+ 			}
+ 		}		
+ 		
  		// Split out the meta_key only queries (we can only do this for OR)
  		if ( 'OR' == $this->relation ) {
  			foreach ( $this->queries as $k => $q ) {
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-blogs.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-blogs.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-blogs.php	2012-11-17 09:11:29.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-blogs.php	2013-04-29 07:49:33.000000000 -0500
***************
*** 43,56 ****
   * @return string
   */
  function get_blogaddress_by_name( $blogname ) {
- 	global $current_site;
- 
  	if ( is_subdomain_install() ) {
  		if ( $blogname == 'main' )
  			$blogname = 'www';
  		$url = rtrim( network_home_url(), '/' );
  		if ( !empty( $blogname ) )
! 			$url = preg_replace( '|^([^\.]+://)|', '$1' . $blogname . '.', $url );
  	} else {
  		$url = network_home_url( $blogname );
  	}
--- 43,54 ----
   * @return string
   */
  function get_blogaddress_by_name( $blogname ) {
  	if ( is_subdomain_install() ) {
  		if ( $blogname == 'main' )
  			$blogname = 'www';
  		$url = rtrim( network_home_url(), '/' );
  		if ( !empty( $blogname ) )
! 			$url = preg_replace( '|^([^\.]+://)|', "\${1}" . $blogname . '.', $url );
  	} else {
  		$url = network_home_url( $blogname );
  	}
***************
*** 84,90 ****
  }
  
  /**
!  * Given a blog's (subdomain or directory) slug, retrieve it's id.
   *
   * @since MU
   *
--- 82,88 ----
  }
  
  /**
!  * Given a blog's (subdomain or directory) slug, retrieve its id.
   *
   * @since MU
   *
***************
*** 254,259 ****
--- 252,267 ----
  function refresh_blog_details( $blog_id ) {
  	$blog_id = (int) $blog_id;
  	$details = get_blog_details( $blog_id, false );
+ 	if ( ! $details ) {
+ 		// Make sure clean_blog_cache() gets the blog ID
+ 		// when the blog has been previously cached as
+ 		// non-existent.
+ 		$details = (object) array(
+ 			'blog_id' => $blog_id,
+ 			'domain' => null,
+ 			'path' => null
+ 		);
+ 	}
  
  	clean_blog_cache( $details );
  
***************
*** 461,467 ****
   * @param int $id The blog id
   * @param string $option The option key
   * @param mixed $value The option value
!  * @return bool True on success, false on failrue.
   */
  function update_blog_option( $id, $option, $value, $deprecated = null ) {
  	$id = (int) $id;
--- 469,475 ----
   * @param int $id The blog id
   * @param string $option The option key
   * @param mixed $value The option value
!  * @return bool True on success, false on failure.
   */
  function update_blog_option( $id, $option, $value, $deprecated = null ) {
  	$id = (int) $id;
***************
*** 687,692 ****
--- 695,702 ----
  		( $value == 1 ) ? do_action( 'archive_blog', $blog_id ) : do_action( 'unarchive_blog', $blog_id );
  	elseif ( 'deleted' == $pref )
  		( $value == 1 ) ? do_action( 'make_delete_blog', $blog_id ) : do_action( 'make_undelete_blog', $blog_id );
+ 	elseif ( 'public' == $pref )
+ 		do_action( 'update_blog_public', $blog_id, $value ); // Moved here from update_blog_public().
  
  	return $value;
  }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-default-filters.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-default-filters.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-default-filters.php	2012-09-11 17:22:20.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-default-filters.php	2013-07-31 01:46:02.000000000 -0500
***************
*** 63,66 ****
  remove_filter( 'option_home',    '_config_wp_home'    );
  
  // If the network upgrade hasn't run yet, assume ms-files.php rewriting is used.
! add_filter( 'default_site_option_ms_files_rewriting', '__return_true' );
\ No newline at end of file
--- 63,69 ----
  remove_filter( 'option_home',    '_config_wp_home'    );
  
  // If the network upgrade hasn't run yet, assume ms-files.php rewriting is used.
! add_filter( 'default_site_option_ms_files_rewriting', '__return_true' );
! 
! // Whitelist multisite domains for HTTP requests
! add_filter( 'http_request_host_is_external', 'ms_allowed_http_request_hosts', 20, 2 );
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-deprecated.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-deprecated.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-deprecated.php	2012-08-08 12:11:15.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-deprecated.php	2013-02-15 21:02:15.000000000 -0600
***************
*** 270,272 ****
--- 270,301 ----
  	}
  	return $url;
  }
+ 
+ /**
+  * Get a numeric user ID from either an email address or a login.
+  *
+  * A numeric string is considered to be an existing user ID
+  * and is simply returned as such.
+  *
+  * @since MU
+  * @deprecated 3.6.0
+  * @deprecated Use get_user_by()
+  * @uses get_user_by()
+  *
+  * @param string $string Either an email address or a login.
+  * @return int
+  */
+ function get_user_id_from_string( $string ) {
+ 	_deprecated_function( __FUNCTION__, '3.6', 'get_user_by()' );
+ 
+ 	if ( is_email( $string ) )
+ 		$user = get_user_by( 'email', $string );
+ 	elseif ( is_numeric( $string ) )
+ 		return $string;
+ 	else
+ 		$user = get_user_by( 'login', $string );
+ 
+ 	if ( $user )
+ 		return $user->ID;
+ 	return 0;
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-files.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-files.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-files.php	2012-01-08 11:01:11.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-files.php	2013-05-20 15:20:22.000000000 -0500
***************
*** 57,63 ****
  header( 'ETag: ' . $etag );
  header( 'Expires: ' . gmdate( 'D, d M Y H:i:s', time() + 100000000 ) . ' GMT' );
  
! // Support for Conditional GET
  $client_etag = isset( $_SERVER['HTTP_IF_NONE_MATCH'] ) ? stripslashes( $_SERVER['HTTP_IF_NONE_MATCH'] ) : false;
  
  if( ! isset( $_SERVER['HTTP_IF_MODIFIED_SINCE'] ) )
--- 57,63 ----
  header( 'ETag: ' . $etag );
  header( 'Expires: ' . gmdate( 'D, d M Y H:i:s', time() + 100000000 ) . ' GMT' );
  
! // Support for Conditional GET - use stripslashes to avoid formatting.php dependency
  $client_etag = isset( $_SERVER['HTTP_IF_NONE_MATCH'] ) ? stripslashes( $_SERVER['HTTP_IF_NONE_MATCH'] ) : false;
  
  if( ! isset( $_SERVER['HTTP_IF_MODIFIED_SINCE'] ) )
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-functions.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-functions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ms-functions.php	2012-12-06 03:43:52.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ms-functions.php	2013-05-01 13:39:56.000000000 -0500
***************
*** 279,287 ****
   * @return int The ID of the newly created blog
   */
  function create_empty_blog( $domain, $path, $weblog_title, $site_id = 1 ) {
- 	$domain			= addslashes( $domain );
- 	$weblog_title	= addslashes( $weblog_title );
- 
  	if ( empty($path) )
  		$path = '/';
  
--- 279,284 ----
***************
*** 463,471 ****
  		$errors->add( 'user_name', __( 'Sorry, usernames may not contain the character &#8220;_&#8221;!' ) );
  
  	// all numeric?
! 	$match = array();
! 	preg_match( '/[0-9]*/', $user_name, $match );
! 	if ( $match[0] == $user_name )
  		$errors->add('user_name', __('Sorry, usernames must have letters too!'));
  
  	if ( !is_email( $user_email ) )
--- 460,466 ----
  		$errors->add( 'user_name', __( 'Sorry, usernames may not contain the character &#8220;_&#8221;!' ) );
  
  	// all numeric?
! 	if ( preg_match( '/^[0-9]*$/', $user_name ) )
  		$errors->add('user_name', __('Sorry, usernames must have letters too!'));
  
  	if ( !is_email( $user_email ) )
***************
*** 497,505 ****
  			$wpdb->delete( $wpdb->signups, array( 'user_login' => $user_name ) );
  		else
  			$errors->add('user_name', __('That username is currently reserved but may be available in a couple of days.'));
- 
- 		if ( $signup->active == 0 && $signup->user_email == $user_email )
- 			$errors->add('user_email_used', __('username and email used'));
  	}
  
  	$signup = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->signups WHERE user_email = %s", $user_email) );
--- 492,497 ----
***************
*** 570,576 ****
  	if ( strlen( $blogname ) < 4 && !is_super_admin() )
  		$errors->add('blogname',  __( 'Site name must be at least 4 characters.' ) );
  
! 	if ( strpos( ' ' . $blogname, '_' ) != false )
  		$errors->add( 'blogname', __( 'Sorry, site names may not contain the character &#8220;_&#8221;!' ) );
  
  	// do not allow users to create a blog that conflicts with a page on the main blog.
--- 562,568 ----
  	if ( strlen( $blogname ) < 4 && !is_super_admin() )
  		$errors->add('blogname',  __( 'Site name must be at least 4 characters.' ) );
  
! 	if ( strpos( $blogname, '_' ) !== false )
  		$errors->add( 'blogname', __( 'Sorry, site names may not contain the character &#8220;_&#8221;!' ) );
  
  	// do not allow users to create a blog that conflicts with a page on the main blog.
***************
*** 578,591 ****
  		$errors->add( 'blogname', __( 'Sorry, you may not use that site name.' ) );
  
  	// all numeric?
! 	$match = array();
! 	preg_match( '/[0-9]*/', $blogname, $match );
! 	if ( $match[0] == $blogname )
  		$errors->add('blogname', __('Sorry, site names must have letters too!'));
  
  	$blogname = apply_filters( 'newblogname', $blogname );
  
! 	$blog_title = stripslashes(  $blog_title );
  
  	if ( empty( $blog_title ) )
  		$errors->add('blog_title', __( 'Please enter a site title.' ) );
--- 570,581 ----
  		$errors->add( 'blogname', __( 'Sorry, you may not use that site name.' ) );
  
  	// all numeric?
! 	if ( preg_match( '/^[0-9]*$/', $blogname ) )
  		$errors->add('blogname', __('Sorry, site names must have letters too!'));
  
  	$blogname = apply_filters( 'newblogname', $blogname );
  
! 	$blog_title = wp_unslash(  $blog_title );
  
  	if ( empty( $blog_title ) )
  		$errors->add('blog_title', __( 'Please enter a site title.' ) );
***************
*** 639,647 ****
  
  	$key = substr( md5( time() . rand() . $domain ), 0, 16 );
  	$meta = serialize($meta);
- 	$domain = $wpdb->escape($domain);
- 	$path = $wpdb->escape($path);
- 	$title = $wpdb->escape($title);
  
  	$wpdb->insert( $wpdb->signups, array(
  		'domain' => $domain,
--- 629,634 ----
***************
*** 820,826 ****
   * @uses wp_generate_password()
   * @uses wpmu_welcome_user_notification()
   * @uses add_user_to_blog()
-  * @uses add_new_user_to_blog()
   * @uses wpmu_create_user()
   * @uses wpmu_create_blog()
   * @uses wpmu_welcome_notification()
--- 807,812 ----
***************
*** 844,857 ****
  	}
  
  	$meta = maybe_unserialize($signup->meta);
- 	$user_login = $wpdb->escape($signup->user_login);
- 	$user_email = $wpdb->escape($signup->user_email);
  	$password = wp_generate_password( 12, false );
  
! 	$user_id = username_exists($user_login);
  
  	if ( ! $user_id )
! 		$user_id = wpmu_create_user($user_login, $password, $user_email);
  	else
  		$user_already_exists = true;
  
--- 830,841 ----
  	}
  
  	$meta = maybe_unserialize($signup->meta);
  	$password = wp_generate_password( 12, false );
  
! 	$user_id = username_exists($signup->user_login);
  
  	if ( ! $user_id )
! 		$user_id = wpmu_create_user($signup->user_login, $password, $signup->user_email);
  	else
  		$user_already_exists = true;
  
***************
*** 866,876 ****
  		if ( isset( $user_already_exists ) )
  			return new WP_Error( 'user_already_exists', __( 'That username is already activated.' ), $signup);
  
! 		wpmu_welcome_user_notification($user_id, $password, $meta);
! 
! 		add_new_user_to_blog( $user_id, $user_email, $meta );
! 		do_action('wpmu_activate_user', $user_id, $password, $meta);
! 		return array('user_id' => $user_id, 'password' => $password, 'meta' => $meta);
  	}
  
  	$blog_id = wpmu_create_blog( $signup->domain, $signup->path, $signup->title, $user_id, $meta, $wpdb->siteid );
--- 850,858 ----
  		if ( isset( $user_already_exists ) )
  			return new WP_Error( 'user_already_exists', __( 'That username is already activated.' ), $signup);
  
! 		wpmu_welcome_user_notification( $user_id, $password, $meta );
! 		do_action( 'wpmu_activate_user', $user_id, $password, $meta );
! 		return array( 'user_id' => $user_id, 'password' => $password, 'meta' => $meta );
  	}
  
  	$blog_id = wpmu_create_blog( $signup->domain, $signup->path, $signup->title, $user_id, $meta, $wpdb->siteid );
***************
*** 909,923 ****
   * @param string $email The new user's email address.
   * @return mixed Returns false on failure, or int $user_id on success
   */
! function wpmu_create_user( $user_name, $password, $email) {
  	$user_name = preg_replace( '/\s+/', '', sanitize_user( $user_name, true ) );
  
  	$user_id = wp_create_user( $user_name, $password, $email );
! 	if ( is_wp_error($user_id) )
  		return false;
  
  	// Newly created users have no roles or caps until they are added to a blog.
! 	delete_user_option( $user_id, 'capabilities' );
  	delete_user_option( $user_id, 'user_level' );
  
  	do_action( 'wpmu_new_user', $user_id );
--- 891,907 ----
   * @param string $email The new user's email address.
   * @return mixed Returns false on failure, or int $user_id on success
   */
! function wpmu_create_user( $user_name, $password, $email ) {
  	$user_name = preg_replace( '/\s+/', '', sanitize_user( $user_name, true ) );
  
  	$user_id = wp_create_user( $user_name, $password, $email );
! 	if ( is_wp_error( $user_id ) )
  		return false;
  
+ 	$user = new WP_User( $user_id );
+ 
  	// Newly created users have no roles or caps until they are added to a blog.
! 	delete_user_option( $user_id, $user->cap_key );
  	delete_user_option( $user_id, 'user_level' );
  
  	do_action( 'wpmu_new_user', $user_id );
***************
*** 1028,1034 ****
  URL: %2$s
  Remote IP: %3$s
  
! Disable these notifications: %4$s' ), $blogname, $siteurl, $_SERVER['REMOTE_ADDR'], $options_site_url);
  	$msg = apply_filters( 'newblog_notify_siteadmin', $msg );
  
  	wp_mail( $email, sprintf( __( 'New Site Registration: %s' ), $siteurl ), $msg );
--- 1012,1018 ----
  URL: %2$s
  Remote IP: %3$s
  
! Disable these notifications: %4$s' ), $blogname, $siteurl, wp_unslash( $_SERVER['REMOTE_ADDR'] ), $options_site_url);
  	$msg = apply_filters( 'newblog_notify_siteadmin', $msg );
  
  	wp_mail( $email, sprintf( __( 'New Site Registration: %s' ), $siteurl ), $msg );
***************
*** 1062,1068 ****
  	$msg = sprintf(__('New User: %1$s
  Remote IP: %2$s
  
! Disable these notifications: %3$s'), $user->user_login, $_SERVER['REMOTE_ADDR'], $options_site_url);
  
  	$msg = apply_filters( 'newuser_notify_siteadmin', $msg, $user );
  	wp_mail( $email, sprintf(__('New User Registration: %s'), $user->user_login), $msg );
--- 1046,1052 ----
  	$msg = sprintf(__('New User: %1$s
  Remote IP: %2$s
  
! Disable these notifications: %3$s'), $user->user_login, wp_unslash( $_SERVER['REMOTE_ADDR'] ), $options_site_url);
  
  	$msg = apply_filters( 'newuser_notify_siteadmin', $msg, $user );
  	wp_mail( $email, sprintf(__('New User Registration: %s'), $user->user_login), $msg );
***************
*** 1111,1118 ****
  	if ( ! $result )
  		return false;
  
! 	refresh_blog_details($wpdb->insert_id);
! 	return $wpdb->insert_id;
  }
  
  /**
--- 1095,1103 ----
  	if ( ! $result )
  		return false;
  
! 	$blog_id = $wpdb->insert_id;
! 	refresh_blog_details( $blog_id );
! 	return $blog_id;
  }
  
  /**
***************
*** 1160,1166 ****
  	else
  		update_option( 'upload_path', get_blog_option( $current_site->blog_id, 'upload_path' ) );
  
! 	update_option( 'blogname', stripslashes( $blog_title ) );
  	update_option( 'admin_email', '' );
  
  	// remove all perms
--- 1145,1151 ----
  	else
  		update_option( 'upload_path', get_blog_option( $current_site->blog_id, 'upload_path' ) );
  
! 	update_option( 'blogname', wp_unslash( $blog_title ) );
  	update_option( 'admin_email', '' );
  
  	// remove all perms
***************
*** 1217,1225 ****
  	if ( !apply_filters('wpmu_welcome_notification', $blog_id, $user_id, $password, $title, $meta) )
  		return false;
  
! 	$welcome_email = stripslashes( get_site_option( 'welcome_email' ) );
  	if ( $welcome_email == false )
! 		$welcome_email = stripslashes( __( 'Dear User,
  
  Your new SITE_NAME site has been successfully set up at:
  BLOG_URL
--- 1202,1210 ----
  	if ( !apply_filters('wpmu_welcome_notification', $blog_id, $user_id, $password, $title, $meta) )
  		return false;
  
! 	$welcome_email = get_site_option( 'welcome_email' );
  	if ( $welcome_email == false )
! 		$welcome_email = __( 'Dear User,
  
  Your new SITE_NAME site has been successfully set up at:
  BLOG_URL
***************
*** 1231,1237 ****
  
  We hope you enjoy your new site. Thanks!
  
! --The Team @ SITE_NAME' ) );
  
  	$url = get_blogaddress_by_id($blog_id);
  	$user = get_userdata( $user_id );
--- 1216,1222 ----
  
  We hope you enjoy your new site. Thanks!
  
! --The Team @ SITE_NAME' );
  
  	$url = get_blogaddress_by_id($blog_id);
  	$user = get_userdata( $user_id );
***************
*** 1255,1261 ****
  	if ( empty( $current_site->site_name ) )
  		$current_site->site_name = 'WordPress';
  
! 	$subject = apply_filters( 'update_welcome_subject', sprintf(__('New %1$s Site: %2$s'), $current_site->site_name, stripslashes( $title ) ) );
  	wp_mail($user->user_email, $subject, $message, $message_headers);
  	return true;
  }
--- 1240,1246 ----
  	if ( empty( $current_site->site_name ) )
  		$current_site->site_name = 'WordPress';
  
! 	$subject = apply_filters( 'update_welcome_subject', sprintf(__('New %1$s Site: %2$s'), $current_site->site_name, wp_unslash( $title ) ) );
  	wp_mail($user->user_email, $subject, $message, $message_headers);
  	return true;
  }
***************
*** 1324,1355 ****
  }
  
  /**
-  * Get a numeric user ID from either an email address or a login.
-  *
-  * @since MU
-  * @uses is_email()
-  *
-  * @param string $string
-  * @return int
-  */
- function get_user_id_from_string( $string ) {
- 	$user_id = 0;
- 	if ( is_email( $string ) ) {
- 		$user = get_user_by('email', $string);
- 		if ( $user )
- 			$user_id = $user->ID;
- 	} elseif ( is_numeric( $string ) ) {
- 		$user_id = $string;
- 	} else {
- 		$user = get_user_by('login', $string);
- 		if ( $user )
- 			$user_id = $user->ID;
- 	}
- 
- 	return $user_id;
- }
- 
- /**
   * Get a user's most recent post.
   *
   * Walks through each of a user's blogs to find the post with
--- 1309,1314 ----
***************
*** 1510,1516 ****
  function wpmu_log_new_registrations( $blog_id, $user_id ) {
  	global $wpdb;
  	$user = get_userdata( (int) $user_id );
! 	$wpdb->insert( $wpdb->registration_log, array('email' => $user->user_email, 'IP' => preg_replace( '/[^0-9., ]/', '',$_SERVER['REMOTE_ADDR'] ), 'blog_id' => $blog_id, 'date_registered' => current_time('mysql')) );
  }
  
  /**
--- 1469,1475 ----
  function wpmu_log_new_registrations( $blog_id, $user_id ) {
  	global $wpdb;
  	$user = get_userdata( (int) $user_id );
! 	$wpdb->insert( $wpdb->registration_log, array('email' => $user->user_email, 'IP' => preg_replace( '/[^0-9., ]/', '', wp_unslash( $_SERVER['REMOTE_ADDR'] ) ), 'blog_id' => $blog_id, 'date_registered' => current_time('mysql')) );
  }
  
  /**
***************
*** 1709,1721 ****
  /**
   * Add a newly created user to the appropriate blog
   *
   * @since MU
   *
   * @param int $user_id
!  * @param string $email
   * @param array $meta
   */
! function add_new_user_to_blog( $user_id, $email, $meta ) {
  	global $current_site;
  	if ( !empty( $meta[ 'add_to_blog' ] ) ) {
  		$blog_id = $meta[ 'add_to_blog' ];
--- 1668,1684 ----
  /**
   * Add a newly created user to the appropriate blog
   *
+  * To add a user in general, use add_user_to_blog(). This function
+  * is specifically hooked into the wpmu_activate_user action.
+  *
   * @since MU
+  * @see add_user_to_blog()
   *
   * @param int $user_id
!  * @param mixed $password Ignored.
   * @param array $meta
   */
! function add_new_user_to_blog( $user_id, $password, $meta ) {
  	global $current_site;
  	if ( !empty( $meta[ 'add_to_blog' ] ) ) {
  		$blog_id = $meta[ 'add_to_blog' ];
***************
*** 1737,1760 ****
  }
  
  /**
!  * Check to see whether a user is marked as a spammer, based on username
   *
   * @since MU
!  * @uses get_current_user_id()
!  * @uses get_user_id_from_string()
   *
!  * @param string $username
   * @return bool
   */
! function is_user_spammy( $username = 0 ) {
! 	if ( $username == 0 ) {
! 		$user_id = get_current_user_id();
! 	} else {
! 		$user_id = get_user_id_from_string( $username );
! 	}
! 	$u = get_userdata( $user_id );
  
! 	return ( isset( $u->spam ) && $u->spam == 1 );
  }
  
  /**
--- 1700,1720 ----
  }
  
  /**
!  * Check to see whether a user is marked as a spammer, based on user login.
   *
   * @since MU
!  * @uses get_user_by()
   *
!  * @param string $user_login Optional. Defaults to current user.
   * @return bool
   */
! function is_user_spammy( $user_login = null ) {
! 	if ( $user_login )
! 		$user = get_user_by( 'login', $user_login );
! 	else
! 		$user = wp_get_current_user();
  
! 	return $user && isset( $user->spam ) && 1 == $user->spam;
  }
  
  /**
***************
*** 1770,1778 ****
   * @return bool
   */
  function update_blog_public( $old_value, $value ) {
! 	global $wpdb;
! 	do_action('update_blog_public');
! 	update_blog_status( $wpdb->blogid, 'public', (int) $value );
  }
  add_action('update_option_blog_public', 'update_blog_public', 10, 2);
  
--- 1730,1736 ----
   * @return bool
   */
  function update_blog_public( $old_value, $value ) {
! 	update_blog_status( get_current_blog_id(), 'public', (int) $value );
  }
  add_action('update_option_blog_public', 'update_blog_public', 10, 2);
  
***************
*** 2013,2016 ****
  		return min( $size, $fileupload_maxk );
  
  	return min( $size, $fileupload_maxk, get_upload_space_available() );
! }
\ No newline at end of file
--- 1971,1994 ----
  		return min( $size, $fileupload_maxk );
  
  	return min( $size, $fileupload_maxk, get_upload_space_available() );
! }
! 
! /**
!  * Whether or not we have a large network.
!  *
!  * The default criteria for a large network is either more than 10,000 users or more than 10,000 sites.
!  * Plugins can alter this criteria using the 'wp_is_large_network' filter.
!  *
!  * @since 3.3.0
!  * @param string $using 'sites or 'users'. Default is 'sites'.
!  * @return bool True if the network meets the criteria for large. False otherwise.
!  */
! function wp_is_large_network( $using = 'sites' ) {
! 	if ( 'users' == $using ) {
! 		$count = get_user_count();
! 		return apply_filters( 'wp_is_large_network', $count > 10000, 'users', $count );
! 	}
! 
! 	$count = get_blog_count();
! 	return apply_filters( 'wp_is_large_network', $count > 10000, 'sites', $count );
! }
